/* Copyright (C) 2000 Cyrano SA
 
   This file is part of OpenSTA
 
   OpenSTA is free software; you can redistribute it and/or modify it under
   the terms of the GNU General Public License as published by the Free
   Software Foundation; either version 2, or (at your option) any later
   version.
 
   OpenSTA is distributed in the hope that it will be useful, but WITHOUT ANY
   WARRANTY; without even the implied warranty of MERCHANTABILITY or
   FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
   for more details.
 
   You should have received a copy of the GNU General Public License along
   with OpenSTA; see the file COPYING.  If not, write to the Free Software
   Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
 
   For more information about the GNU Public license see:
   http://www.gnu.org/copyleft/gpl.html
 
   OpenSTA is at:
   http://www.opensta.org/
   http://opensta.sourceforge.net/
*/

#ifndef _CCONFIG_TABLE
#define _CCONFIG_TABLE

#ifdef WIN32
#pragma warning(disable:4786)
#pragma warning(disable:4503)
#endif

#include <string>
#include <map>
#ifdef HPUX
#include <iostream.h>
#else
#include <iostream>
#endif

#ifndef CYR_NO_STD_NAMESPACE
using namespace std;
#endif
#if defined (WIN32)
//++
class CConfigTable;
ostream& operator<<(ostream&, const CConfigTable&);
//--
#endif

enum addValueResult { OK, BAD_ROW_ID, BAD_COL_ID, REDIM_ERROR };

typedef map<int,string,less<int> > _CONFIG_COLUMN; // Table column
class CConfigTable
{
    typedef map<string,_CONFIG_COLUMN*,less<string> > _CONFIG_TABLE; // Table

    _CONFIG_COLUMN* _singleColTable; //
    _CONFIG_TABLE* _multiColTable;

    // Helper function.
    const string ChangeCase(const string& stingIn) const;
public :
    // Constructor, and destructor.
    CConfigTable();
    CConfigTable(const CConfigTable& configIn);
    ~CConfigTable();
    // Accessors
    const string GetValue(int row) const;
    const string GetValue(string column, int row) const;
    const _CONFIG_COLUMN* GetColumn() const;
    const _CONFIG_COLUMN* GetColumn(string colName) const;
    // Mutators
    addValueResult AddValue(const string& rowString,const string& colVal);
    // Operators
    friend ostream& operator<<(ostream& os, const CConfigTable& table);
private:
    operator=(const CConfigTable& configIn);
};
#endif
