/* Copyright (C) 2000 Cyrano SA
 
   This file is part of OpenSTA
 
   OpenSTA is free software; you can redistribute it and/or modify it under
   the terms of the GNU General Public License as published by the Free
   Software Foundation; either version 2, or (at your option) any later
   version.
 
   OpenSTA is distributed in the hope that it will be useful, but WITHOUT ANY
   WARRANTY; without even the implied warranty of MERCHANTABILITY or
   FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
   for more details.
 
   You should have received a copy of the GNU General Public License along
   with OpenSTA; see the file COPYING.  If not, write to the Free Software
   Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
 
   For more information about the GNU Public license see:
   http://www.gnu.org/copyleft/gpl.html
 
   OpenSTA is at:
   http://www.opensta.org/
   http://opensta.sourceforge.net/
*/

// odl.h

#ifndef odl_h
#define odl_h

#include <string>
#ifndef CYR_NO_STD_NAMESPACE
using namespace std;
#endif

// Object attribute flag bits
#define OA_HIDDEN   1       // Hidden object

// Property attribute flag bits
#define PA_VARS		1		// Allow variable substitution
#define PA_ENCRYPT	(1<<1)	// Store encrypted
#define PA_HIDDEN   (1<<2)  // Hidden property
#define PA_NOSEARCH (1<<3)  // Non searchable property
#define PA_REPEATABLE (1<<4) // Repeatable field

// Attribute text for odl file
static const string PATXT_VARS		("varsub");
static const string PATXT_ENCRYPT   ("encrypt");
static const string PATXT_HIDDEN    ("hidden");
static const string PATXT_NOSEARCH  ("nosearch");
static const string PATXT_DECLARE	("declaration");
static const string PATXT_REPEATABLE("repeatable");

// Property display flag bits
#define PD_EDIT		1		// Display in Edit control
#define PD_COMBO	(1<<1)	// Display in Combo box
#define PD_VSB		(1<<2)  // Vertical scrollbar
#define PD_HSB		(1<<3)	// Horizontal scrollbar
#define PD_AVS		(1<<4)	// Auto vertical scroll
#define PD_AHS		(1<<5)	// Auto horizontal scroll
#define PD_RDONLY	(1<<6)	// Readonly property
#define PD_PASSWD	(1<<7)	// Password (***) field
#define PD_ILIST	(1<<8)  // Value from/to internal list
#define PD_NSUBS    (1<<9)  // Flowbox name substitutions
#define PD_DROPLIST (1<<10) // Display in dropdown listbox
#define PD_LISTDATA (1<<11) // Dropbox content from context listdata

// Display attribute text for odl file
static const string PDTXT_COMBO     ("combobox");
static const string PDTXT_VSB       ("vscroll");
static const string PDTXT_HSB       ("hscroll");
static const string PDTXT_AHS       ("ahscroll");
static const string PDTXT_RDONLY    ("readonly");
static const string PDTXT_PASSWD    ("password");
static const string PDTXT_ILIST     ("ilist");
static const string PDTXT_NSUBS     ("nasubs");
static const string PDTXT_NUMBER    ("number");
static const string PDTXT_DROPLIST  ("droplist");
static const string PDTXT_DATANAME	("dataname");
static const string PDTXT_LISTDATA	("listdata");
static const string PDTXT_RANGE		("range");
static const string PDTXT_REGEX		("regex");

// Declaration record keywords for odl file
static const string DECL_VARDEF     ("VARDEF");
static const string DECL_FILDEF     ("FILDEF");
static const string DECL_THRDEF     ("THRDEF");

#define ODL_UNDEF   0
#define ODL_INT     1
#define ODL_FLOAT   2
#define ODL_STRING  3
#define ODL_CHAR    4
#define ODL_BOOL    5
#define ODL_DATANAME 6
#define ODL_RANGE	7
#define ODL_REGEX	8

#endif

#define odlh_stupid_compiler
