#ifndef PSL__PSLDATE_PRMDEF_LOADED
#define PSL__PSLDATE_PRMDEF_LOADED 1
/* Copyright (C) 2000 Cyrano SA
 
   This file is part of OpenSTA
 
   OpenSTA is free software; you can redistribute it and/or modify it under
   the terms of the GNU General Public License as published by the Free
   Software Foundation; either version 2, or (at your option) any later
   version.
 
   OpenSTA is distributed in the hope that it will be useful, but WITHOUT ANY
   WARRANTY; without even the implied warranty of MERCHANTABILITY or
   FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
   for more details.
 
   You should have received a copy of the GNU General Public License along
   with OpenSTA; see the file COPYING.  If not, write to the Free Software
   Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
 
   For more information about the GNU Public license see:
   http://www.gnu.org/copyleft/gpl.html
 
   OpenSTA is at:
   http://www.opensta.org/
   http://opensta.sourceforge.net/
*/

/*===========================================================================*/
/*                                       */
/*               **** C O M M O N ****                   */
/*                                       */
/*===========================================================================*/
/*                                       */
/*          Module Name: PSLDATE_PRMDEF              */
/*          ============                         */
/*                                       */
/* Description:                                  */
/* ============                                  */
/*                                       */
/*  Symbolic Names for Parameters to PSL_FORMAT_DATE             */
/*                                       */
/*                                       */
/*===========================================================================*/

/*** MODULE PSLDATE_PRMDEF ***/
/*   Date Types */
#define            PSDTYP_SYSTEM 1  /* Use default System Format */
#define            PSDTYP_PSL 2 /* Use fixed PSL Format */
#define            PSDTYP_CTM 3 /* Use CTM Format   */
#define            PSDTYP_SQL 4 /* Use fixed SQL format*/
/*   Format Flags */
#define            PSDFMT_DATE 0X1  /* Format Date */
#define            PSDFMT_TIME 0X2  /* Format Time */
#define            PSDFMT_CENTURY 0X4   /* Include Century in Date */
#define            PSDFMT_MILLISEC 0X8  /* Milli-secs in Time   */
#define            PSDFMT_NOSEC 0X10    /* No secs (or msecs) in Time */

/*   Parse Flags */
#define            PSDPRS_DATE 0X1  /* Allow Date */
#define            PSDPRS_TIME 0X2  /* Allow Time */
#define            PSDPRS_CENTURY 0X4   /* Insist on Century in Date */
#define            PSDPRS_Y2KCOMPLIANT 0X8
/* Apply Y"K Compliant rules */
/*   Parsed Field Flags */
#define            PSDFLD_CENTURY 0X1   /* Century was Parsed */
#define            PSDFLD_YEAR 0X2  /* Year was Parsed */
#define            PSDFLD_MONTH 0X4 /* Month was Parsed */
#define            PSDFLD_DAY 0X8   /* Day was Parsed */
#define            PSDFLD_DATE 0XF  /* Date was Parsed */
#define            PSDFLD_HOUR 0X10 /* Hour was Parsed */
#define            PSDFLD_MINUTE 0X20   /* Minutes was Parsed */
#define            PSDFLD_SECOND 0X40   /* Seconds was Parsed */
#define            PSDFLD_MSECS 0X80    /* Milli-seconds was Parsed */
#define            PSDFLD_TIME 0XF0 /* Time was Parsed */
/*   Weekday Numbers */

/*   Note that routine don't care which day is the start of the week, */
/*   but DO insist that the value of that day is zero. */
#define            PSWKDY_SUNDAY 0  /* Sunday */
#define            PSWKDY_MONDAY 1  /* Monday */
#define            PSWKDY_TUESDAY 2 /* Tuesday */
#define            PSWKDY_WEDNESDAY 3   /* Wednesday */
#define            PSWKDY_THURSDAY 4    /* Thursday */
#define            PSWKDY_FRIDAY 5  /* Friday */
#define            PSWKDY_SATURDAY 6    /* Saturday */

/*  End of C Include File */

#endif  /* PSL__PSLDATE_PRMDEF_LOADED */
