/* Copyright (C) 2000 Cyrano SA
 
   This file is part of OpenSTA
 
   OpenSTA is free software; you can redistribute it and/or modify it under
   the terms of the GNU General Public License as published by the Free
   Software Foundation; either version 2, or (at your option) any later
   version.
 
   OpenSTA is distributed in the hope that it will be useful, but WITHOUT ANY
   WARRANTY; without even the implied warranty of MERCHANTABILITY or
   FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
   for more details.
 
   You should have received a copy of the GNU General Public License along
   with OpenSTA; see the file COPYING.  If not, write to the Free Software
   Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
 
   For more information about the GNU Public license see:
   http://www.gnu.org/copyleft/gpl.html
 
   OpenSTA is at:
   http://www.opensta.org/
   http://opensta.sourceforge.net/
*/

/*===========================================================================*/
/*                                       */
/*                **** V T E S T ****                    */
/*                                       */
/*===========================================================================*/
/*                                       */
/*          Module Name: VTEST_MACROS                */
/*          ============                         */
/*                                       */
/* Description:                                  */
/* ============                                  */
/*                                       */
/*  Macros for the VTEST Sub-System.                     */
/*                                       */
/*===========================================================================*/

/*
 *  Define symbol to ensure tracing code is compiled.
 *
 *  ***************************************************************************
 *  Note regarding FINAL build:
 *  ---------------------------
 *  The PSL_TRACING symbol defined here should be commented out in order to
 *  remove tracing code.
 */
/*** #define PSL_TRACING ***/
/*  ***************************************************************************/
/*
 *  Make sure the PSL versions of memory functions are called when PSL_TRACING
 *  is defined.
 */
#ifdef PSL_TRACING
#define MALLOC(a)   PSL_MALLOC(a)
#define CALLOC(a,b) PSL_CALLOC(a,b)
#define FREE(m)     PSL_FREE(m)

#else
#define MALLOC(a)   malloc(a)
#define CALLOC(a,b) calloc(a,b)
#define FREE(m)     free(m)
#endif




/*
 *  End of Macros.
 */
