/* Copyright (C) 2001 Cyrano SA
 
   This file is part of OpenSTA
 
   OpenSTA is free software; you can redistribute it and/or modify it under
   the terms of the GNU General Public License as published by the Free
   Software Foundation; either version 2, or (at your option) any later
   version.
 
   OpenSTA is distributed in the hope that it will be useful, but WITHOUT ANY
   WARRANTY; without even the implied warranty of MERCHANTABILITY or
   FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
   for more details.
 
   You should have received a copy of the GNU General Public License along
   with OpenSTA; see the file COPYING.  If not, write to the Free Software
   Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
 
   For more information about the GNU Public license see:
   http://www.gnu.org/copyleft/gpl.html
 
   OpenSTA is at:
   http://www.opensta.org/
   http://opensta.sourceforge.net/
*/

// WorkspaceBar.cpp : implementation file
//

#include "stdafx.h"
#include "Commander.h"
#include "WorkspaceBar.h"
#include "Mainfrm.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CWorkspaceBar dialog
#define IDC_OBJECTTREE 1000

CWorkspaceBar::CWorkspaceBar(CWnd* pParent /*=NULL*/)
{
	//{{AFX_DATA_INIT(CWorkspaceBar)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
}


BEGIN_MESSAGE_MAP(CWorkspaceBar, CSizingControlBarG)
	//{{AFX_MSG_MAP(CWorkspaceBar)
	ON_WM_CREATE()
	ON_WM_SIZE()
	ON_WM_ERASEBKGND()
	//}}AFX_MSG_MAP
	ON_NOTIFY(NM_DBLCLK,IDC_OBJECTTREE, OnObjectTreeSelect)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CWorkspaceBar message handlers

int CWorkspaceBar::OnCreate(LPCREATESTRUCT lpCreateStruct) 
{
	if (CSizingControlBarG::OnCreate(lpCreateStruct) == -1)
		return -1;

	m_ctlObjectTree.Create(WS_CHILD|WS_VISIBLE|TVS_HASLINES|TVS_HASBUTTONS|TVS_EDITLABELS|TVS_SHOWSELALWAYS,
						CRect(0,0,0,0),this,IDC_OBJECTTREE);

	m_ctlObjectTree.ModifyStyleEx(0,WS_EX_CLIENTEDGE);
	
	return 0;
}

void CWorkspaceBar::OnSize(UINT nType, int cx, int cy) 
{
	CSizingControlBarG::OnSize(nType, cx, cy);
	
	if(m_ctlObjectTree.GetSafeHwnd())
		m_ctlObjectTree.MoveWindow(0,0,cx,cy);
}

BOOL CWorkspaceBar::OnEraseBkgnd(CDC* pDC) 
{
	return true;
}

void CWorkspaceBar::OnObjectTreeSelect(NMHDR* pNMHDR, LRESULT* pResult) 
{
	HTREEITEM hItem = m_ctlObjectTree.GetSelectedItem();

	CString strPath = m_ctlObjectTree.GetItemPath(hItem);

	CMainFrame *pMainWnd = (CMainFrame*)AfxGetMainWnd();
	pMainWnd->OpenFile(strPath);
	
	*pResult = 0;
}

