// CustomTabCtrl.cpp : implementation file
//

#include "stdafx.h"
#include "CustomTabCtrl.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CCustomTabCtrl

CCustomTabCtrl::CCustomTabCtrl()
{
	m_pCurrentTab = NULL;
}

CCustomTabCtrl::~CCustomTabCtrl()
{
}


BEGIN_MESSAGE_MAP(CCustomTabCtrl, CTabCtrl)
	//{{AFX_MSG_MAP(CCustomTabCtrl)
	ON_WM_ERASEBKGND()
	ON_NOTIFY_REFLECT(TCN_SELCHANGE, OnSelchange)
	ON_WM_SIZE()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CCustomTabCtrl message handlers

BOOL CCustomTabCtrl::OnEraseBkgnd(CDC* pDC) 
{
	CRect rcClient;
	GetClientRect(&rcClient);

	CRect rcTabs(rcClient);
	AdjustRect(FALSE,rcTabs);

	pDC->ExcludeClipRect(rcTabs);

	return CTabCtrl::OnEraseBkgnd(pDC);
}

void CCustomTabCtrl::OnSelchange(NMHDR* pNMHDR, LRESULT* pResult) 
{
	int nCurSel = GetCurSel();
	if(nCurSel == -1)
		return;

	SetCurrentWindow(nCurSel);
	
	*pResult = 0;
}

void CCustomTabCtrl::OnSize(UINT nType, int cx, int cy) 
{
	CTabCtrl::OnSize(nType, cx, cy);
	
	CRect rcClient(0,0,cx,cy);
	AdjustRect(FALSE,rcClient);

	if(m_pCurrentTab)
		m_pCurrentTab->MoveWindow(rcClient);
}

BOOL CCustomTabCtrl::InsertItem(int nItem,LPCTSTR lpszItem,int nImage,CWnd *pWnd)
{
	m_arWndTabs.SetAtGrow(nItem,pWnd);
	return CTabCtrl::InsertItem(nItem,lpszItem,nImage);
}

int CCustomTabCtrl::InsertItem(int nItem,LPCTSTR lpszItem,CWnd *pWnd)
{
	m_arWndTabs.SetAtGrow(nItem,pWnd);
	return CTabCtrl::InsertItem(nItem,lpszItem);
}

int CCustomTabCtrl::SetCurSel(int nItem)
{
	SetCurrentWindow(nItem);
	return CTabCtrl::SetCurSel(nItem);
}

void CCustomTabCtrl::SetCurrentWindow(int nNdx)
{
	if(m_pCurrentTab)
		m_pCurrentTab->ShowWindow(SW_HIDE);
	
	m_pCurrentTab = m_arWndTabs[nNdx];

	CRect rcClient;
	GetClientRect(&rcClient);
	AdjustRect(FALSE,rcClient);

	m_pCurrentTab->MoveWindow(rcClient);
	m_pCurrentTab->ShowWindow(SW_SHOW);
}