// DataNameCtrls.cpp : implementation file
//

#include "stdafx.h"
#include "DataNameCtrls.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

inline BOOL CheckDataName(char *szText)
{
	const int nMaxLength = 16;

	int nLength = strlen(szText);
	if(!nLength)
		return true;

	//Check the length is less than the maximum
	if(nLength>nMaxLength)
		return false;

	//Cannot start with a number
	if(isdigit(*szText))
		return false;

	BOOL bHyphen=false;
	while(*szText)
	{
		if((*szText == '-') || (*szText == '_'))
		{
			if(bHyphen)		//Found two concurrent hyphens(error)
				return false;
			bHyphen = true;		//found hyphen so set hyphen flag
		}
		else
		if(iscsym(*szText))
			bHyphen = false;	//reset hyphen flag
		else
			return false;

		szText++;	//go to next char
	}
	return true;
}

/////////////////////////////////////////////////////////////////////////////
// CDataNameEdit

CDataNameEdit::CDataNameEdit()
{
}

CDataNameEdit::~CDataNameEdit()
{
}


BEGIN_MESSAGE_MAP(CDataNameEdit, CEdit)
	//{{AFX_MSG_MAP(CDataNameEdit)
	ON_CONTROL_REFLECT(EN_CHANGE, OnChange)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CDataNameEdit message handlers

void CDataNameEdit::OnChange() 
{
	CString strText;
	GetWindowText(strText);

	if(CheckDataName(strText.GetBuffer(0)))
	{
		m_strPrevText = strText;	//Name is correct
		return;
	}

	int nStart,nEnd;
	GetSel(nStart,nEnd);
	nStart--;
	nEnd--;
	
	//Restore last name...
	SetWindowText(m_strPrevText);
	
	//and selection
	SetSel(nStart,nEnd);
}

void CDataNameEdit::PreSubclassWindow() 
{
	ModifyStyle(0,ES_UPPERCASE);
	
	GetWindowText(m_strPrevText);
		
	CEdit::PreSubclassWindow();
}

