/* Copyright (C) 2001 Cyrano SA
 
   This file is part of OpenSTA
 
   OpenSTA is free software; you can redistribute it and/or modify it under
   the terms of the GNU General Public License as published by the Free
   Software Foundation; either version 2, or (at your option) any later
   version.
 
   OpenSTA is distributed in the hope that it will be useful, but WITHOUT ANY
   WARRANTY; without even the implied warranty of MERCHANTABILITY or
   FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
   for more details.
 
   You should have received a copy of the GNU General Public License along
   with OpenSTA; see the file COPYING.  If not, write to the Free Software
   Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
 
   For more information about the GNU Public license see:
   http://www.gnu.org/copyleft/gpl.html
 
   OpenSTA is at:
   http://www.opensta.org/
   http://opensta.sourceforge.net/
*/

#if !defined(AFX_CONFIGURATIONDLG_H__0298A273_D4CA_11D4_94C7_00C04F89E392__INCLUDED_)
#define AFX_CONFIGURATIONDLG_H__0298A273_D4CA_11D4_94C7_00C04F89E392__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// ConfigurationDlg.h : header file
//
#include "DragDropDialog.h"
#include "TestCtrl.h"
#include "TestFile.h"

class CTestPluginDoc;

class CConfigurationDlg : public CDragDropDialog
{
// Construction
public:
	CConfigurationDlg(CWnd* pParent = NULL);   // standard constructor

// Dialog Data
	//{{AFX_DATA(CConfigurationDlg)
	enum { IDD = IDD_CONFIGURATION };
	CTestCtrl	m_ctlTestList;
	//}}AFX_DATA

	void SetDocument(CTestPluginDoc* pDoc);
	void GenerateScripts();

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CConfigurationDlg)
	public:
	virtual BOOL PreTranslateMessage(MSG* pMsg);
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	typedef enum{enNameCol,enHostCol,enVUCol,enFirstTaskCol} ListColumns;
	typedef enum{enHostImage,enVUImage,enNameImage} ConfigImages;

	// Generated message map functions
	//{{AFX_MSG(CConfigurationDlg)
	afx_msg void OnSize(UINT nType, int cx, int cy);
	virtual BOOL OnInitDialog();
	afx_msg void OnBegindragTestsList(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnDblclkTestList(NMHDR* pNMHDR, LRESULT* pResult);
	//}}AFX_MSG
	afx_msg BOOL OnEraseBkgnd(CDC* pDC);
	DECLARE_MESSAGE_MAP()

	virtual DROPEFFECT OnDragEnter(COleDataObject* pDataObject, DWORD dwKeyState, CPoint point);
	virtual void OnDragLeave();
	virtual DROPEFFECT OnDragOver(COleDataObject* pDataObject, DWORD dwKeyState, CPoint point);
	virtual BOOL OnDrop(COleDataObject* pDataObject, DROPEFFECT dropEffect, CPoint point);

	void GenerateTaskGroupScripts(int nGroup);
	void GenerateTaskGroupTSS(int nGroup);
	void GenerateTaskGroupSCL(int nGroup);
	CString GetScriptHeader(const CString&);
	CString GetScriptOutputPath();

	void SetupTestList();
	
	CString GetTargetType(const CString& strPath);
	
	CImageList m_ListImages;
	CMap <CString,LPCTSTR,int,int> m_mapExtToImage;
	int RegisterFileExtension(const CString& strFile);

	void InsertItem(int nItem,int nSubItem,const CString& strItemPath);
	void InsertScript(int nItem,int nSubItem,const CString& strItemPath);
	void InsertProfile(int nItem,int nSubItem,const CString& strItemPath);
	BOOL EditScriptTask(int nGroup,int nTask);
	BOOL EditHost(int nGroup);
	BOOL EditVUs(int nGroup);
	BOOL EditProfileTask(int nGroup);
	
	void DeleteItem(int nGroup,int nTask);

	void LoadTestFile(CTestFile* pFile);
private:
	CTestPluginDoc *m_pDoc;
	CTestFile *m_pTestFile;

	CString m_strTestName;
	CString m_strTestFolder;

	const int m_nMaxTasks,m_nMaxGroups;
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_CONFIGURATIONDLG_H__0298A273_D4CA_11D4_94C7_00C04F89E392__INCLUDED_)
