/* Copyright (C) 2001 Cyrano SA
 
   This file is part of OpenSTA
 
   OpenSTA is free software; you can redistribute it and/or modify it under
   the terms of the GNU General Public License as published by the Free
   Software Foundation; either version 2, or (at your option) any later
   version.
 
   OpenSTA is distributed in the hope that it will be useful, but WITHOUT ANY
   WARRANTY; without even the implied warranty of MERCHANTABILITY or
   FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
   for more details.
 
   You should have received a copy of the GNU General Public License along
   with OpenSTA; see the file COPYING.  If not, write to the Free Software
   Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
 
   For more information about the GNU Public license see:
   http://www.gnu.org/copyleft/gpl.html
 
   OpenSTA is at:
   http://www.opensta.org/
   http://opensta.sourceforge.net/
*/

// Plugin.cpp: implementation of the CPlugin class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "Plugin.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CPlugin::CPlugin(HINSTANCE hDLL , int nType, CString szTitle, CString szPackage)
        : m_hDLL(hDLL) ,m_nType(nType), m_szTitle(szTitle), m_szPackage(szPackage)
{
}

CPlugin::~CPlugin()
{
	if (m_hDLL)
	{
		FreeLibrary(m_hDLL);
	}
}

HINSTANCE CPlugin::GetHandle()
{
	return m_hDLL;
}

int CPlugin::GetType()
{
	return m_nType;
}

CString CPlugin::GetTitle()
{
	return m_szTitle;
}

CString CPlugin::GetPackage()
{
	return m_szPackage;
}

FARPROC CPlugin::GetFunction (CString FunctionName)
{
    FARPROC fProc = ::GetProcAddress(m_hDLL ,FunctionName);

    return fProc;
}