/* Copyright (C) 2001 Cyrano SA
 
   This file is part of OpenSTA
 
   OpenSTA is free software; you can redistribute it and/or modify it under
   the terms of the GNU General Public License as published by the Free
   Software Foundation; either version 2, or (at your option) any later
   version.
 
   OpenSTA is distributed in the hope that it will be useful, but WITHOUT ANY
   WARRANTY; without even the implied warranty of MERCHANTABILITY or
   FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
   for more details.
 
   You should have received a copy of the GNU General Public License along
   with OpenSTA; see the file COPYING.  If not, write to the Free Software
   Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
 
   For more information about the GNU Public license see:
   http://www.gnu.org/copyleft/gpl.html
 
   OpenSTA is at:
   http://www.opensta.org/
   http://opensta.sourceforge.net/
*/

#if !defined(AFX_RESULTSDLG_H__81F44675_D4E6_11D4_94C7_00C04F89E392__INCLUDED_)
#define AFX_RESULTSDLG_H__81F44675_D4E6_11D4_94C7_00C04F89E392__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// ResultsDlg.h : header file
//

/////////////////////////////////////////////////////////////////////////////
// CResultsDlg dialog
#include "DragDropDialog.h"
#include "XChartCtrl.h"

class CTestFile;
class CResultsDlg : public CDragDropDialog
{
// Construction
public:
	CResultsDlg(CWnd* pParent = NULL);   // standard constructor

// Dialog Data
	//{{AFX_DATA(CResultsDlg)
	enum { IDD = IDD_RESULTS };
	CButton	m_ctlShowHideBtn;
	CStatic	m_ctlGraphsCaption;
	CStatic	m_ctlRunsCaption;
	CButton	m_ctlFilters;
	CStatic	m_ctlListFrame;
	CListBox	m_ctlRuns;
	CListBox	m_ctlGraphs;
	//}}AFX_DATA

	void SetTestFile(CTestFile* pFile);

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CResultsDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:

	void FillRunList();
	CXChartCtrl* AddGraph();

	// Generated message map functions
	//{{AFX_MSG(CResultsDlg)
	virtual BOOL OnInitDialog();
	afx_msg void OnSize(UINT nType, int cx, int cy);
	afx_msg void OnFilters();
	afx_msg void OnSelchangeRuns();
	afx_msg void OnSelchangeGraphTypes();
	afx_msg void OnDestroy();
	afx_msg void OnShowhideBtn();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()

	CList <CXChartCtrl*,CXChartCtrl*> m_listCharts;

	CTestFile *m_pTestFile;
	CString m_strTestFolder;

	int m_nLastGraphAdded;

	typedef struct
	{
		CString strGraphTitle;	//Name displayed in graph listbox
		CString strPlugin;	//Plugin name
		int nGraphIndex;		//Graph listbox item data
	}GraphType;

	CArray <GraphType,GraphType&> m_arGraphs;

	CWnd *m_pCurrentGraph;
	BOOL m_bFrameHidden;
	CBitmap m_bmpShowHide;

	const CString m_strAuditLogName;
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_RESULTSDLG_H__81F44675_D4E6_11D4_94C7_00C04F89E392__INCLUDED_)
