/* Copyright (C) 2001 Cyrano SA
 
   This file is part of OpenSTA
 
   OpenSTA is free software; you can redistribute it and/or modify it under
   the terms of the GNU General Public License as published by the Free
   Software Foundation; either version 2, or (at your option) any later
   version.
 
   OpenSTA is distributed in the hope that it will be useful, but WITHOUT ANY
   WARRANTY; without even the implied warranty of MERCHANTABILITY or
   FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
   for more details.
 
   You should have received a copy of the GNU General Public License along
   with OpenSTA; see the file COPYING.  If not, write to the Free Software
   Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
 
   For more information about the GNU Public license see:
   http://www.gnu.org/copyleft/gpl.html
 
   OpenSTA is at:
   http://www.opensta.org/
   http://opensta.sourceforge.net/
*/

// ScriptDefData.h: interface for the CScriptDefData class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_SCRIPTDEFDATA_H__E68D8C84_D72A_11D4_94C8_00C04F89E392__INCLUDED_)
#define AFX_SCRIPTDEFDATA_H__E68D8C84_D72A_11D4_94C8_00C04F89E392__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

class CScriptDefData  
{
public:
	CScriptDefData();
	virtual ~CScriptDefData();
	
	BOOL SaveToBuffer(LPBYTE pData,DWORD &dwBufSize);
	BOOL LoadFromBuffer(LPBYTE pData);

	void SetNumIterations(int n){m_nNumIterations = n;}
	void SetMaxIterDelay(int n){m_nMaxIterDelay = n;}
	void SetMinIterDelay(int n){m_nMinIterDelay = n;}
	void SetFixedIterDelay(int n){m_nFixedIterDelay = n;}
	void SetUseFixedIterDelay(BOOL b){m_bConstantDelay = b;}

	int GetNumIterations(){return m_nNumIterations;}
	int GetMaxIterDelay(){return m_nMaxIterDelay;}
	int GetMinIterDelay(){return m_nMinIterDelay;}
	int GetFixedIterDelay(){return m_nFixedIterDelay;}
	BOOL GetUseFixedIterDelay(){return m_bConstantDelay;}
	
private:	
	int		m_nNumIterations;
	int		m_nMaxIterDelay;
	int		m_nMinIterDelay;
	int		m_nFixedIterDelay;
	BOOL	m_bConstantDelay;
};

#endif // !defined(AFX_SCRIPTDEFDATA_H__E68D8C84_D72A_11D4_94C8_00C04F89E392__INCLUDED_)
