/* Copyright (C) 2001 Cyrano SA
 
   This file is part of OpenSTA
 
   OpenSTA is free software; you can redistribute it and/or modify it under
   the terms of the GNU General Public License as published by the Free
   Software Foundation; either version 2, or (at your option) any later
   version.
 
   OpenSTA is distributed in the hope that it will be useful, but WITHOUT ANY
   WARRANTY; without even the implied warranty of MERCHANTABILITY or
   FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
   for more details.
 
   You should have received a copy of the GNU General Public License along
   with OpenSTA; see the file COPYING.  If not, write to the Free Software
   Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
 
   For more information about the GNU Public license see:
   http://www.gnu.org/copyleft/gpl.html
 
   OpenSTA is at:
   http://www.opensta.org/
   http://opensta.sourceforge.net/
*/

// TaskGroupDefData.cpp: implementation of the TaskGroupDefData class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "TestPlugin.h"
#include "TaskGroupDefData.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CTaskGroupDefData::CTaskGroupDefData()
{
	m_nStartInterval = 0;
	m_nNumVUs = 1;
	m_nVUPerInterval = 01;
	m_bGenPageTimers = FALSE;
	m_chStatLevel = 'L';
}

CTaskGroupDefData::~CTaskGroupDefData()
{

}

BOOL CTaskGroupDefData::SaveToBuffer(LPBYTE pData,DWORD &dwBufferSize)
{
	const int nVersion=0;
	
	//Calculate required buffer size
	DWORD dwRequiredSize = sizeof(int);	//version

	dwRequiredSize += sizeof(int);		//start interval
	dwRequiredSize += sizeof(int);		//Num VUs
	dwRequiredSize += sizeof(int);		//VUs per interval
	dwRequiredSize += sizeof(int);		//Stat level
	dwRequiredSize += sizeof(BOOL);		//Gen Page Timers
	
	if(dwBufferSize < dwRequiredSize)
	{
		dwBufferSize = dwRequiredSize;		//buffer is too small
		return false;
	}
	
	LPBYTE pDataPos = pData;
	
	memcpy(pDataPos,&nVersion,sizeof(int));
	pDataPos+=sizeof(int);

	memcpy(pDataPos,&m_nStartInterval,sizeof(int));
	pDataPos+=sizeof(int);

	memcpy(pDataPos,&m_nNumVUs,sizeof(int));
	pDataPos+=sizeof(int);

	memcpy(pDataPos,&m_nVUPerInterval,sizeof(int));
	pDataPos+=sizeof(int);

	memcpy(pDataPos,&m_chStatLevel,sizeof(char));
	pDataPos+=sizeof(int);

	memcpy(pDataPos,&m_bGenPageTimers,sizeof(BOOL));
	pDataPos+=sizeof(BOOL);

	return true;
}

BOOL CTaskGroupDefData::LoadFromBuffer(LPBYTE pData)
{
	if(!pData)
		return false;

	LPBYTE pDataPos = pData;

	int nVersion;
	memcpy(&nVersion,pDataPos,sizeof(int));
	pDataPos+=sizeof(int);

	if(nVersion == 0)
	{
		memcpy(&m_nStartInterval,pDataPos,sizeof(int));
		pDataPos+=sizeof(int);

		memcpy(&m_nNumVUs,pDataPos,sizeof(int));
		pDataPos+=sizeof(int);

		memcpy(&m_nVUPerInterval,pDataPos,sizeof(int));
		pDataPos+=sizeof(int);

		memcpy(&m_chStatLevel,pDataPos,sizeof(char));
		pDataPos+=sizeof(int);

		memcpy(&m_bGenPageTimers,pDataPos,sizeof(BOOL));
		pDataPos+=sizeof(BOOL);
	}

	return true;
}