/* Copyright (C) 2001 Cyrano SA
 
   This file is part of OpenSTA
 
   OpenSTA is free software; you can redistribute it and/or modify it under
   the terms of the GNU General Public License as published by the Free
   Software Foundation; either version 2, or (at your option) any later
   version.
 
   OpenSTA is distributed in the hope that it will be useful, but WITHOUT ANY
   WARRANTY; without even the implied warranty of MERCHANTABILITY or
   FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
   for more details.
 
   You should have received a copy of the GNU General Public License along
   with OpenSTA; see the file COPYING.  If not, write to the Free Software
   Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
 
   For more information about the GNU Public license see:
   http://www.gnu.org/copyleft/gpl.html
 
   OpenSTA is at:
   http://www.opensta.org/
   http://opensta.sourceforge.net/
*/

#if !defined(AFX_RESULTSDLG_H__CC49FB39_EAC4_11D4_94CA_00C04F89E392__INCLUDED_)
#define AFX_RESULTSDLG_H__CC49FB39_EAC4_11D4_94CA_00C04F89E392__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// ResultsDlg.h : header file
//

/////////////////////////////////////////////////////////////////////////////
// CResultsDlg dialog
#include "CECGridCtrl.h"

class CResultsDlg : public CDialog
{
// Construction
public:
	CResultsDlg(CWnd* pParent = NULL);   // standard constructor

// Dialog Data
	//{{AFX_DATA(CResultsDlg)
	enum { IDD = IDD_VIEWER_DLG };
	CComboBox	m_ctlAuditType;
	//}}AFX_DATA
	CECGridCtrl m_ctlResultsList;

	BOOL SetRunFolder(const CString& strPath);
// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CResultsDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:

	// Generated message map functions
	//{{AFX_MSG(CResultsDlg)
	virtual BOOL OnInitDialog();
	afx_msg void OnSize(UINT nType, int cx, int cy);
	afx_msg void OnSelchangeType();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()

	CString m_strRunFolder;

	typedef enum{enAudit,enHistory,enReport} AuditType;
	BOOL ShowType(AuditType nType);
	BOOL ShowAudit();
	BOOL ShowReport();
	BOOL ShowHistory();
	BOOL ShowHistoryInPath(const CString& strRunFolder);
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_RESULTSDLG_H__CC49FB39_EAC4_11D4_94CA_00C04F89E392__INCLUDED_)
