/* Copyright (C) 2001 Cyrano SA
 
   This file is part of OpenSTA
 
   OpenSTA is free software; you can redistribute it and/or modify it under
   the terms of the GNU General Public License as published by the Free
   Software Foundation; either version 2, or (at your option) any later
   version.
 
   OpenSTA is distributed in the hope that it will be useful, but WITHOUT ANY
   WARRANTY; without even the implied warranty of MERCHANTABILITY or
   FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
   for more details.
 
   You should have received a copy of the GNU General Public License along
   with OpenSTA; see the file COPYING.  If not, write to the Free Software
   Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
 
   For more information about the GNU Public license see:
   http://www.gnu.org/copyleft/gpl.html
 
   OpenSTA is at:
   http://www.opensta.org/
   http://opensta.sourceforge.net/
*/

// XAuditViewerCtl.cpp : Implementation of the CXAuditViewerCtrl ActiveX Control class.

#include "stdafx.h"
#include "XAuditViewer.h"
#include "XAuditViewerCtl.h"
#include "XAuditViewerPpg.h"


#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif


IMPLEMENT_DYNCREATE(CXAuditViewerCtrl, COleControl)


/////////////////////////////////////////////////////////////////////////////
// Message map

BEGIN_MESSAGE_MAP(CXAuditViewerCtrl, COleControl)
	//{{AFX_MSG_MAP(CXAuditViewerCtrl)
	ON_WM_CREATE()
	ON_WM_SIZE()
	//}}AFX_MSG_MAP
	ON_OLEVERB(AFX_IDS_VERB_PROPERTIES, OnProperties)
END_MESSAGE_MAP()


/////////////////////////////////////////////////////////////////////////////
// Dispatch map

BEGIN_DISPATCH_MAP(CXAuditViewerCtrl, COleControl)
	//{{AFX_DISPATCH_MAP(CXAuditViewerCtrl)
	DISP_FUNCTION(CXAuditViewerCtrl, "SetRunFolder", SetRunFolder, VT_BOOL, VTS_BSTR)
	//}}AFX_DISPATCH_MAP
END_DISPATCH_MAP()


/////////////////////////////////////////////////////////////////////////////
// Event map

BEGIN_EVENT_MAP(CXAuditViewerCtrl, COleControl)
	//{{AFX_EVENT_MAP(CXAuditViewerCtrl)
	// NOTE - ClassWizard will add and remove event map entries
	//    DO NOT EDIT what you see in these blocks of generated code !
	//}}AFX_EVENT_MAP
END_EVENT_MAP()


/////////////////////////////////////////////////////////////////////////////
// Property pages

// TODO: Add more property pages as needed.  Remember to increase the count!
BEGIN_PROPPAGEIDS(CXAuditViewerCtrl, 1)
	PROPPAGEID(CXAuditViewerPropPage::guid)
END_PROPPAGEIDS(CXAuditViewerCtrl)


/////////////////////////////////////////////////////////////////////////////
// Initialize class factory and guid

IMPLEMENT_OLECREATE_EX(CXAuditViewerCtrl, "XAUDITVIEWER.XAuditViewerCtrl.1",
	0xcc49fb28, 0xeac4, 0x11d4, 0x94, 0xca, 0, 0xc0, 0x4f, 0x89, 0xe3, 0x92)


/////////////////////////////////////////////////////////////////////////////
// Type library ID and version

IMPLEMENT_OLETYPELIB(CXAuditViewerCtrl, _tlid, _wVerMajor, _wVerMinor)


/////////////////////////////////////////////////////////////////////////////
// Interface IDs

const IID BASED_CODE IID_DXAuditViewer =
		{ 0xcc49fb26, 0xeac4, 0x11d4, { 0x94, 0xca, 0, 0xc0, 0x4f, 0x89, 0xe3, 0x92 } };
const IID BASED_CODE IID_DXAuditViewerEvents =
		{ 0xcc49fb27, 0xeac4, 0x11d4, { 0x94, 0xca, 0, 0xc0, 0x4f, 0x89, 0xe3, 0x92 } };


/////////////////////////////////////////////////////////////////////////////
// Control type information

static const DWORD BASED_CODE _dwXAuditViewerOleMisc =
	OLEMISC_ACTIVATEWHENVISIBLE |
	OLEMISC_SETCLIENTSITEFIRST |
	OLEMISC_INSIDEOUT |
	OLEMISC_CANTLINKINSIDE |
	OLEMISC_RECOMPOSEONRESIZE;

IMPLEMENT_OLECTLTYPE(CXAuditViewerCtrl, IDS_XAUDITVIEWER, _dwXAuditViewerOleMisc)


/////////////////////////////////////////////////////////////////////////////
// CXAuditViewerCtrl::CXAuditViewerCtrlFactory::UpdateRegistry -
// Adds or removes system registry entries for CXAuditViewerCtrl

BOOL CXAuditViewerCtrl::CXAuditViewerCtrlFactory::UpdateRegistry(BOOL bRegister)
{
	// TODO: Verify that your control follows apartment-model threading rules.
	// Refer to MFC TechNote 64 for more information.
	// If your control does not conform to the apartment-model rules, then
	// you must modify the code below, changing the 6th parameter from
	// afxRegApartmentThreading to 0.

	if (bRegister)
		return AfxOleRegisterControlClass(
			AfxGetInstanceHandle(),
			m_clsid,
			m_lpszProgID,
			IDS_XAUDITVIEWER,
			IDB_XAUDITVIEWER,
			afxRegApartmentThreading,
			_dwXAuditViewerOleMisc,
			_tlid,
			_wVerMajor,
			_wVerMinor);
	else
		return AfxOleUnregisterClass(m_clsid, m_lpszProgID);
}


/////////////////////////////////////////////////////////////////////////////
// CXAuditViewerCtrl::CXAuditViewerCtrl - Constructor

CXAuditViewerCtrl::CXAuditViewerCtrl()
{
	InitializeIIDs(&IID_DXAuditViewer, &IID_DXAuditViewerEvents);

	// TODO: Initialize your control's instance data here.
}


/////////////////////////////////////////////////////////////////////////////
// CXAuditViewerCtrl::~CXAuditViewerCtrl - Destructor

CXAuditViewerCtrl::~CXAuditViewerCtrl()
{
	// TODO: Cleanup your control's instance data here.
}


/////////////////////////////////////////////////////////////////////////////
// CXAuditViewerCtrl::OnDraw - Drawing function

void CXAuditViewerCtrl::OnDraw(
			CDC* pdc, const CRect& rcBounds, const CRect& rcInvalid)
{
	if(!m_ResultsDlg.GetSafeHwnd())
	{
		pdc->FillRect(rcBounds, CBrush::FromHandle((HBRUSH)GetStockObject(WHITE_BRUSH)));
		pdc->TextOut(0,0,"XAuditViewer.ocx");
	}
}


/////////////////////////////////////////////////////////////////////////////
// CXAuditViewerCtrl::DoPropExchange - Persistence support

void CXAuditViewerCtrl::DoPropExchange(CPropExchange* pPX)
{
	ExchangeVersion(pPX, MAKELONG(_wVerMinor, _wVerMajor));
	COleControl::DoPropExchange(pPX);

	// TODO: Call PX_ functions for each persistent custom property.

}


/////////////////////////////////////////////////////////////////////////////
// CXAuditViewerCtrl::OnResetState - Reset control to default state

void CXAuditViewerCtrl::OnResetState()
{
	COleControl::OnResetState();  // Resets defaults found in DoPropExchange

	// TODO: Reset any other control state here.
}


/////////////////////////////////////////////////////////////////////////////
// CXAuditViewerCtrl message handlers
int CXAuditViewerCtrl::OnCreate(LPCREATESTRUCT lpCreateStruct) 
{
	if (COleControl::OnCreate(lpCreateStruct) == -1)
		return -1;
	
	m_ResultsDlg.Create(IDD_VIEWER_DLG,this);
	
	return 0;
}

BOOL CXAuditViewerCtrl::SetRunFolder(LPCTSTR szRunFolder) 
{
	return m_ResultsDlg.SetRunFolder(szRunFolder);
}


void CXAuditViewerCtrl::OnSize(UINT nType, int cx, int cy) 
{
	COleControl::OnSize(nType, cx, cy);
	
	if(m_ResultsDlg.GetSafeHwnd())
		m_ResultsDlg.MoveWindow(0,0,cx,cy);
}
