/* Copyright (C) 2000 Cyrano SA
 
   This file is part of OpenSTA
 
   OpenSTA is free software; you can redistribute it and/or modify it under
   the terms of the GNU General Public License as published by the Free
   Software Foundation; either version 2, or (at your option) any later
   version.
 
   OpenSTA is distributed in the hope that it will be useful, but WITHOUT ANY
   WARRANTY; without even the implied warranty of MERCHANTABILITY or
   FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
   for more details.
 
   You should have received a copy of the GNU General Public License along
   with OpenSTA; see the file COPYING.  If not, write to the Free Software
   Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
 
   For more information about the GNU Public license see:
   http://www.gnu.org/copyleft/gpl.html
 
   OpenSTA is at:
   http://www.opensta.org/
   http://opensta.sourceforge.net/
*/

#if !defined(AFX_XCHARTCTRLCTL_H__F2333887_678E_11D4_948A_00C04F89E392__INCLUDED_)
#define AFX_XCHARTCTRLCTL_H__F2333887_678E_11D4_948A_00C04F89E392__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

// XChartCtrlCtl.h : Declaration of the CXChartCtrlCtrl ActiveX Control class.

/////////////////////////////////////////////////////////////////////////////
// CXChartCtrlCtrl : See XChartCtrlCtl.cpp for implementation.

#include "ChartDlg.h"

class CXChartCtrlCtrl : public COleControl
{
    DECLARE_DYNCREATE(CXChartCtrlCtrl)

    // Constructor
public:
    CXChartCtrlCtrl();

    // Overrides
    // ClassWizard generated virtual function overrides
    //{{AFX_VIRTUAL(CXChartCtrlCtrl)
public:
    virtual void OnDraw(CDC* pdc, const CRect& rcBounds, const CRect& rcInvalid);
    virtual void DoPropExchange(CPropExchange* pPX);
    virtual void OnResetState();
    //}}AFX_VIRTUAL

    // Implementation
protected:
    ~CXChartCtrlCtrl();

    DECLARE_OLECREATE_EX(CXChartCtrlCtrl)    // Class factory and guid
    DECLARE_OLETYPELIB(CXChartCtrlCtrl)      // GetTypeInfo
    DECLARE_PROPPAGEIDS(CXChartCtrlCtrl)     // Property page IDs
    DECLARE_OLECTLTYPE(CXChartCtrlCtrl)     // Type name and misc status

    // Message maps
    //{{AFX_MSG(CXChartCtrlCtrl)
    afx_msg int OnCreate(LPCREATESTRUCT lpCreateStruct);
    afx_msg void OnSize(UINT nType, int cx, int cy);
    afx_msg BOOL OnEraseBkgnd(CDC* pDC);
    //}}AFX_MSG
    DECLARE_MESSAGE_MAP()

    // Dispatch maps
    //{{AFX_DISPATCH(CXChartCtrlCtrl)
    afx_msg BSTR GetTitleText();
    afx_msg void SetTitleText(LPCTSTR lpszNewValue);
    afx_msg OLE_COLOR GetTitleBkColor();
    afx_msg void SetTitleBkColor(OLE_COLOR nNewValue);
    afx_msg OLE_COLOR GetPlotBkColor();
    afx_msg void SetPlotBkColor(OLE_COLOR nNewValue);
    afx_msg BSTR GetYAxisLabel();
    afx_msg void SetYAxisLabel(LPCTSTR lpszNewValue);
    afx_msg BSTR GetXAxisLabel();
    afx_msg void SetXAxisLabel(LPCTSTR lpszNewValue);
    afx_msg BSTR GetY2AxisLabel();
    afx_msg void SetY2AxisLabel(LPCTSTR lpszNewValue);
    afx_msg long GetYAxisMinimum();
    afx_msg void SetYAxisMinimum(long nNewValue);
    afx_msg long GetXAxisMinimum();
    afx_msg void SetXAxisMinimum(long nNewValue);
    afx_msg long GetY2AxisMinimum();
    afx_msg void SetY2AxisMinimum(long nNewValue);
    afx_msg long GetYAxisMaximum();
    afx_msg void SetYAxisMaximum(long nNewValue);
    afx_msg long GetXAxisMaximum();
    afx_msg void SetXAxisMaximum(long nNewValue);
    afx_msg long GetY2AxisMaximum();
    afx_msg void SetY2AxisMaximum(long nNewValue);
    afx_msg OLE_COLOR GetTitleTextColor();
    afx_msg void SetTitleTextColor(OLE_COLOR nNewValue);
    afx_msg BSTR GetTitleFont();
    afx_msg void SetTitleFont(LPCTSTR lpszNewValue);
    afx_msg VARIANT GetDataColors();
    afx_msg void SetDataColors(const VARIANT FAR& newValue);
    afx_msg BSTR GetLabelFont();
    afx_msg void SetLabelFont(LPCTSTR lpszNewValue);
    afx_msg OLE_COLOR GetGridColor();
    afx_msg void SetGridColor(OLE_COLOR nNewValue);
    afx_msg OLE_COLOR GetLabelColor();
    afx_msg void SetLabelColor(OLE_COLOR nNewValue);
    afx_msg OLE_COLOR GetAxisTextColor();
    afx_msg void SetAxisTextColor(OLE_COLOR nNewValue);
    afx_msg VARIANT GetData();
    afx_msg void SetData(const VARIANT FAR& newValue);
    afx_msg void ShowLegend(BOOL bShow);
    afx_msg void EditCopy();
    afx_msg void AddDataPoint(long nSeries, double dValue);
    afx_msg void RemoveSeries(LPCTSTR szSeries);
    afx_msg void EnableZoom(BOOL bEnable);
    afx_msg long GetSeriesStyle(long lSeries);
    afx_msg void SetSeriesStyle(long lSeries, long nNewValue);
    afx_msg BSTR GetLegendText(short nSeries);
    afx_msg void SetLegendText(short nSeries, LPCTSTR lpszNewValue);
    afx_msg double GetDataPoint(long nIndex, long nSeries);
    afx_msg void SetDataPoint(long nIndex, long nSeries, double newValue);
    afx_msg BOOL GetSeriesOnSecondaryAxis(short nSeries);
    afx_msg void SetSeriesOnSecondaryAxis(short nSeries, BOOL bNewValue);
    afx_msg BSTR GetSeriesAnnotation(short nSeries);
    afx_msg void SetSeriesAnnotation(short nSeries, LPCTSTR lpszNewValue);
    //}}AFX_DISPATCH
    DECLARE_DISPATCH_MAP()

    // Event maps
    //{{AFX_EVENT(CXChartCtrlCtrl)
    //}}AFX_EVENT
    DECLARE_EVENT_MAP()

    // Dispatch and event IDs
public:
    enum {
        //{{AFX_DISP_ID(CXChartCtrlCtrl)
        dispidTitleText = 1L,
        dispidTitleBkColor = 2L,
        dispidPlotBkColor = 3L,
        dispidYAxisLabel = 4L,
        dispidXAxisLabel = 5L,
        dispidY2AxisLabel = 6L,
        dispidYAxisMinimum = 7L,
        dispidXAxisMinimum = 8L,
        dispidY2AxisMinimum = 9L,
        dispidYAxisMaximum = 10L,
        dispidXAxisMaximum = 11L,
        dispidY2AxisMaximum = 12L,
        dispidTitleTextColor = 13L,
        dispidTitleFont = 14L,
        dispidDataColors = 15L,
        dispidLabelFont = 16L,
        dispidGridColor = 17L,
        dispidLabelColor = 18L,
        dispidAxisTextColor = 19L,
        dispidData = 20L,
        dispidSeriesStyle = 26L,
        dispidShowLegend = 21L,
        dispidLegendText = 27L,
        dispidEditCopy = 22L,
        dispidDataPoint = 28L,
        dispidAddDataPoint = 23L,
        dispidSeriesOnSecondaryAxis = 29L,
        dispidSeriesAnnotation = 30L,
        dispidRemoveSeries = 24L,
        dispidEnableZoom = 25L,
        //}}AFX_DISP_ID
    };

private:
    CChartDlg m_chartDlg;
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_XCHARTCTRLCTL_H__F2333887_678E_11D4_948A_00C04F89E392__INCLUDED)
