/* Copyright (C) 2000 Cyrano SA

   This file is part of OpenSTA

   OpenSTA is free software; you can redistribute it and/or modify it under
   the terms of the GNU General Public License as published by the Free
   Software Foundation; either version 2, or (at your option) any later
   version.

   OpenSTA is distributed in the hope that it will be useful, but WITHOUT ANY
   WARRANTY; without even the implied warranty of MERCHANTABILITY or
   FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
   for more details.

   You should have received a copy of the GNU General Public License along
   with OpenSTA; see the file COPYING.  If not, write to the Free Software
   Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.

   For more information about the GNU Public license see:
   http://www.gnu.org/copyleft/gpl.html

   OpenSTA is at:
   http://www.opensta.org/
   http://opensta.sourceforge.net/
*/

//========================================================================
//
// TEHttpRecords.inl
// -----------------
//=========================================================================

#ifndef TH_POOL_VER
#include "TEHttpRecords.h"
#endif

const AtvfKey TRcrdConnect::		KEY("Connect");
#ifndef TH_POOL_VER
CTMutex TRcrdConnect::m_mutex;
#endif
const AtvfKey TRcrdRequest::		KEY("Request");
#ifndef TH_POOL_VER
CTMutex TRcrdRequest::evaluateMtx;
#endif
const AtvfKey TRcrdDisconnect::		KEY("Disconnect");
const AtvfKey TRcrdHttpResponse::	KEY("Lload");
#ifndef TH_POOL_VER
CTMutex TRcrdHttpResponse::m_mutex;
#endif
const AtvfKey TRcrdSynchronize::	KEY("Synchronize");
#ifndef TH_POOL_VER
CTMutex TRcrdSynchronize::m_mutex;
#endif


//
// tof Section: connect 
const bool TRcrdConnect::_registeredCreator = TRcrdConnect::_RegisterCreator();
const bool TRcrdConnect::_RegisterCreator()
{
	if (!recCreatorMap) recCreatorMap = new RecCreator_map_t;
	(*recCreatorMap)[TRcrdConnect::KEY] = new TRecMake<TRcrdConnect>();
	return true;
}

//
// tof Section: Request 
const bool TRcrdRequest::_registeredCreator = TRcrdRequest::_RegisterCreator();
const bool TRcrdRequest::_RegisterCreator()
{
	if (!recCreatorMap) recCreatorMap = new RecCreator_map_t;
	(*recCreatorMap)[TRcrdRequest::KEY] = new TRecMake<TRcrdRequest>();
	return true;
}

//
// tof Section: disconnect 
const bool TRcrdDisconnect::_registeredCreator = TRcrdDisconnect::_RegisterCreator();
const bool TRcrdDisconnect::_RegisterCreator()
{
	if (!recCreatorMap) recCreatorMap = new RecCreator_map_t;
	(*recCreatorMap)[TRcrdDisconnect::KEY] = new TRecMake<TRcrdDisconnect>();
	return true;
}

//
// tof Section: HttpResponse
const bool TRcrdHttpResponse::_registeredCreator = TRcrdHttpResponse::_RegisterCreator();
const bool TRcrdHttpResponse::_RegisterCreator()
{
	if (!recCreatorMap) recCreatorMap = new RecCreator_map_t;
	(*recCreatorMap)[TRcrdHttpResponse::KEY] = new TRecMake<TRcrdHttpResponse>();
	return true;
}

//
// tof Section: Synchronize
const bool TRcrdSynchronize::_registeredCreator = TRcrdSynchronize::_RegisterCreator();
const bool TRcrdSynchronize::_RegisterCreator()
{
	if (!recCreatorMap) recCreatorMap = new RecCreator_map_t;
	(*recCreatorMap)[TRcrdSynchronize::KEY] = new TRecMake<TRcrdSynchronize>();
	return true;
}
