/* Copyright (C) 2000 Cyrano SA
 
   This file is part of OpenSTA
 
   OpenSTA is free software; you can redistribute it and/or modify it under
   the terms of the GNU General Public License as published by the Free
   Software Foundation; either version 2, or (at your option) any later
   version.
 
   OpenSTA is distributed in the hope that it will be useful, but WITHOUT ANY
   WARRANTY; without even the implied warranty of MERCHANTABILITY or
   FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
   for more details.
 
   You should have received a copy of the GNU General Public License along
   with OpenSTA; see the file COPYING.  If not, write to the Free Software
   Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
 
   For more information about the GNU Public license see:
   http://www.gnu.org/copyleft/gpl.html
 
   OpenSTA is at:
   http://www.opensta.org/
   http://opensta.sourceforge.net/
*/

#include "stdafx.h"
#include "TEMainStructure.hpp"

CMainExecuterStructure g_TExecuter;

int main(int argc, char* argv[])
{
    int iRes = 0;

    HMODULE ole32Lib = LoadLibrary("ole32.dll");    // To avoid troubles on W2K.

    CFastLock::Init();

    if(g_TExecuter.Init(argc, argv) == FALSE)
        return 1;

    if(g_TExecuter.GetCmdLineOptions().option_supplied("-i") || g_TExecuter.GetCmdLineOptions().option_supplied("-u"))
        return 0;   // Was started to install / uninstal the perf counters.

    iRes = g_TExecuter.Run();

    FreeLibrary(ole32Lib);

    return iRes;
}

