/* Copyright (C) 2000 Cyrano SA
 
   This file is part of OpenSTA
 
   OpenSTA is free software; you can redistribute it and/or modify it under
   the terms of the GNU General Public License as published by the Free
   Software Foundation; either version 2, or (at your option) any later
   version.
 
   OpenSTA is distributed in the hope that it will be useful, but WITHOUT ANY
   WARRANTY; without even the implied warranty of MERCHANTABILITY or
   FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
   for more details.
 
   You should have received a copy of the GNU General Public License along
   with OpenSTA; see the file COPYING.  If not, write to the Free Software
   Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
 
   For more information about the GNU Public license see:
   http://www.gnu.org/copyleft/gpl.html
 
   OpenSTA is at:
   http://www.opensta.org/
   http://opensta.sourceforge.net/
*/

// BrowserFileDlg.cpp : implementation file
//

#include "stdafx.h"
#include "concertlib.h"
#include "BrowserFileDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CBrowserFileDlg dialog
//----------------------------------------------------------------------------

BEGIN_MESSAGE_MAP(CBrowserFileDlg, CDialog)
//{{AFX_MSG_MAP(CBrowserFileDlg)
ON_BN_CLICKED(ID_VALFILE_BUTTON, OnValFileButton)
ON_WM_CTLCOLOR()
//}}AFX_MSG_MAP
END_MESSAGE_MAP()

//----------------------------------------------------------------------------

CBrowserFileDlg::CBrowserFileDlg( CString * _pstrBrowserFilePath /*=NULL*/, CWnd* pParent /*=NULL*/ )
        : CDialog(CBrowserFileDlg::IDD, pParent)
{
    //{{AFX_DATA_INIT(CBrowserFileDlg)
    // NOTE: the ClassWizard will add member initialization here
    //}}AFX_DATA_INIT

    m_pstrBrowserFilePath = _pstrBrowserFilePath ;
}

/////////////////////////////////////////////////////////////////////////////
// CBrowserFileDlg message handlers
//----------------------------------------------------------------------------

void CBrowserFileDlg::Values2Ctrl()
{
    SetDlgItemText( ID_BROWSER_FILEPATH_EDIT, *m_pstrBrowserFilePath ) ;
}

//----------------------------------------------------------------------------

void CBrowserFileDlg::Ctrl2Values()
{
    GetDlgItemText( ID_BROWSER_FILEPATH_EDIT, *m_pstrBrowserFilePath ) ;
}

//----------------------------------------------------------------------------

void CBrowserFileDlg::OnOK()
{
    BOOL    bFileExist ;
    CFile   File ;
    //---
    Ctrl2Values() ;

    bFileExist = File.Open( *m_pstrBrowserFilePath, CFile::modeRead ) ;

    if( !bFileExist )
    {
        CString strWarning ;
        //---
        strWarning.LoadString( IDS_WARNING ) ;
        MessageBox( "File not found!" , strWarning, MB_OK ) ;
        return ;
    }
    else
    {
        File.Close() ;
    }

    CDialog::OnOK() ;
}
//----------------------------------------------------------------------------

HBRUSH CBrowserFileDlg::OnCtlColor(CDC* pDC, CWnd* pWnd, UINT nCtlColor)
{
    HBRUSH hbr = CDialog::OnCtlColor(pDC, pWnd, nCtlColor);

    if( nCtlColor == CTLCOLOR_STATIC && pWnd->m_hWnd == GetDlgItem( IDC_TITLE_STATIC )->m_hWnd )
    {
        pDC->SetTextColor( RGB( 0 , 0 , 255 ) ) ;
    }

    return hbr;
}

//----------------------------------------------------------------------------

BOOL CBrowserFileDlg::OnInitDialog()
{
    CDialog::OnInitDialog();

    Values2Ctrl() ;

    GetDlgItem( ID_BROWSER_FILEPATH_EDIT )->SetFocus() ;

    return FALSE;  // return TRUE unless you set the focus to a control
    // EXCEPTION: OCX Property Pages should return FALSE
}

//---------------------------------------------------------------------------


void CBrowserFileDlg::OnValFileButton()
{
    DWORD dwFlags = 0 ;

    dwFlags = OFN_EXPLORER | OFN_FILEMUSTEXIST | OFN_PATHMUSTEXIST ; //OFN_OVERWRITEPROMPT ;

    CFileDialog FileDlg(TRUE) ; //, NULL, NULL, dwFlags, NULL, this) ;

    if (FileDlg.DoModal() == IDOK)
    {
        CWnd* pEdit = static_cast<CWnd*>(GetDlgItem(ID_BROWSER_FILEPATH_EDIT)) ;
        pEdit->SetWindowText( FileDlg.GetPathName() ) ;
    }

}
