#if !defined(AFX_TABLE_H__62CD8E44_05BF_11D2_91BB_00104B4B2995__INCLUDED_)
#define AFX_TABLE_H__62CD8E44_05BF_11D2_91BB_00104B4B2995__INCLUDED_
/* Copyright (C) 2000 Cyrano SA
 
   This file is part of OpenSTA
 
   OpenSTA is free software; you can redistribute it and/or modify it under
   the terms of the GNU General Public License as published by the Free
   Software Foundation; either version 2, or (at your option) any later
   version.
 
   OpenSTA is distributed in the hope that it will be useful, but WITHOUT ANY
   WARRANTY; without even the implied warranty of MERCHANTABILITY or
   FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
   for more details.
 
   You should have received a copy of the GNU General Public License along
   with OpenSTA; see the file COPYING.  If not, write to the Free Software
   Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
 
   For more information about the GNU Public license see:
   http://www.gnu.org/copyleft/gpl.html
 
   OpenSTA is at:
   http://www.opensta.org/
   http://opensta.sourceforge.net/
*/


#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000

//Define standard
#define ID_DATA_NULL        -1
#define SQL_DATA_EXIST      0 // to advertise the user that the data exist

class CDBTable
{

    //Attributes
protected:

    CDatabase*  m_pDatabase;

    HSTMT       m_hstmtI;
    HSTMT       m_hstmtU;
    HSTMT       m_hstmtD;

    BOOL        m_bAlwaysBinding;
    BOOL        m_bFirstTimeI;
    BOOL        m_bFirstTimeU;
    BOOL        m_bFirstTimeD;
    HSTMT       m_hstmtS;

    int         m_nRowSetSize;
    CString     m_strSQL;

    BOOL        m_bIsOpen;
protected:
    SQLCHAR*    GetNullValue( SDWORD, SQLCHAR * );
    SQLINTEGER  GetNullValue( SDWORD, SQLINTEGER );
    SQLDOUBLE   GetNullValue( SDWORD, SQLDOUBLE );

    //Construction
public:
    CDBTable(CDatabase* _pDB, BOOL _bAlwaysBinding = FALSE);
    ~CDBTable();

    //Operation
public:
    virtual BOOL Open(BOOL _bIUD = FALSE);
    BOOL OpenS();
    BOOL OpenI();
    BOOL OpenU();
    BOOL OpenD();

    void Close();
    void Free();
    BOOL DropHstmt(HSTMT* _phstmt);

    void SetSQL(CString _strSQL);
    BOOL IsOpen();
    CDatabase*  GetDatabase();

};

//{{AFX_INSERT_LOCATION}}
// Microsoft Developer Studio will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_TABLE_H__62CD8E44_05BF_11D2_91BB_00104B4B2995__INCLUDED_)
