// HTTPGraphs.h: interface for the CHTTPGraphs class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_HTTPGRAPHS_H__30804214_E70F_11D4_94C9_00C04F89E392__INCLUDED_)
#define AFX_HTTPGRAPHS_H__30804214_E70F_11D4_94C9_00C04F89E392__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

class CHttpStatsOcx;
class CTimerList;
class CGraphWnd;

struct Timer
{
	DWORD dwTimeStamp;
	double dValue;
	DWORD dwActiveUsers;
	CString strTestName;
	CString strThreadName;
	CString strScriptName;
	CString strTimerName;
	bool bInFilter;

	Timer()
	{
		bInFilter = true;
	}
};

typedef CList <Timer*,Timer*> TimerList;

#pragma pack (1)
typedef struct
{
    DWORD dwTimeStamp;
    DWORD dwIP;     //IP Address one byte per field
    DWORD wPID;     //Process Id
    WORD wUser;     //User Number
    DWORD dwResponseTime;
    WORD wResponseCode;
    DWORD dwReplySize;
    int nURLNdx;
}
HttpData;
#pragma pack()

typedef CMap <CString ,LPCTSTR,int,int> URLMap;
typedef CArray<HttpData*,HttpData*> HttpArray;

typedef struct
{
	DWORD dwTimeStamp;
	DWORD dwCount;
}VUData;

typedef CList <VUData*,VUData*> VUList;

class CHTTPGraphs  
{
public:
	CHTTPGraphs();
	virtual ~CHTTPGraphs();

	void LoadRun(const CString& strRunFolder);
	CWnd *DisplayGraph(const CString& strName,CWnd *pParent,const CRect& rcBounds);
	void GetAvailableGraphs(CStringArray& arstrGraphs);

private:
	CHttpStatsOcx*	LoadHTTPDataList(CWnd *pParent,const CRect& rcBounds);
	CTimerList*		LoadTimerList	(CWnd* pParent,const CRect& rcBounds);
	BOOL			LoadTimerGraph	(const CString& strName,CGraphWnd *pGraph);
	CGraphWnd*		LoadTimerGraph(const CString& strName,const CRect& rcBounds,CWnd *pParent);
	CGraphWnd*		LoadHttpGraph(const CString& strName,const CRect& rcBounds,CWnd *pParent);
	CGraphWnd*		LoadVUGraph(const CString& strName,const CRect& rcBounds,CWnd *pParent);

	void LoadTimers();
	void LoadVUData();
	void LoadHttp();
	static int SortHttpData( const void *arg1, const void *arg2 );

private:
	CString m_strLoadedRun;
	DWORD m_dwTestStartTime;

	HttpArray m_arHttp;
	URLMap m_mapURLs;
	TimerList m_listTimers;
	VUList m_listVUs;

	const CString m_strDataList;
	const CString m_strBytesPerSecVTime;
	const CString m_strRespTimeVNumResps;
	const CString m_strErrorsVUsers;
	const CString m_strErrorsVTime;
	const CString m_strRespsVTime;
	const CString m_strRespTimeVTime;
	const CString m_strUsersVTime;
	const CString m_strTimerList;
	const CString m_strTimersVUsers;
	const CString m_strTimersVTime;
};

#endif // !defined(AFX_HTTPGRAPHS_H__30804214_E70F_11D4_94C9_00C04F89E392__INCLUDED_)
