// TimerSelDlg.cpp : implementation file
//

#include "stdafx.h"
#include "TimerSelDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CTimerSelDlg dialog

CTimerSelDlg::CTimerSelDlg(TimerList& listTimers,CWnd* pParent /*=NULL*/)
	: CDialog(CTimerSelDlg::IDD, pParent),
	m_listTimers(listTimers)
{
	//{{AFX_DATA_INIT(CTimerSelDlg)
	//}}AFX_DATA_INIT
}


void CTimerSelDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CTimerSelDlg)
	DDX_Control(pDX, IDC_TIMER_LIST, m_ctlTimerList);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CTimerSelDlg, CDialog)
	//{{AFX_MSG_MAP(CTimerSelDlg)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CTimerSelDlg message handlers

void CTimerSelDlg::OnOK() 
{
    m_arstrTimers.RemoveAll();

    int nSelCount = m_ctlTimerList.GetSelCount();
    int *pSel = new int[nSelCount];
    m_arstrTimers.SetSize(nSelCount);
    m_ctlTimerList.GetSelItems(nSelCount,pSel);
    for(int nNdx=0;nNdx<nSelCount;nNdx++)
        m_ctlTimerList.GetText(pSel[nNdx],m_arstrTimers[nNdx]);
    delete []pSel;

    if(!m_arstrTimers.GetSize())
    {
        CDialog::OnCancel();
        return;
    }
	
	CDialog::OnOK();
}

BOOL CTimerSelDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();

    POSITION pos = m_listTimers.GetHeadPosition();
    while(pos)
    {
        Timer *pTimer = m_listTimers.GetNext(pos);
        if(!pTimer->bInFilter)
            continue;

        if(m_ctlTimerList.FindStringExact(-1,pTimer->strTimerName)==LB_ERR)
            m_ctlTimerList.AddString(pTimer->strTimerName);
    }

	int nCount = m_ctlTimerList.GetCount();
	if(!nCount)
		CDialog::OnCancel();
	else
	if(nCount==1)
	{
		m_arstrTimers.SetSize(1);
		m_ctlTimerList.GetText(0,m_arstrTimers[0]);
 		CDialog::OnOK();
	}

	
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}
