/* Copyright (C) 2000 Cyrano SA
 
   This file is part of OpenSTA
 
   OpenSTA is free software; you can redistribute it and/or modify it under
   the terms of the GNU General Public License as published by the Free
   Software Foundation; either version 2, or (at your option) any later
   version.
 
   OpenSTA is distributed in the hope that it will be useful, but WITHOUT ANY
   WARRANTY; without even the implied warranty of MERCHANTABILITY or
   FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
   for more details.
 
   You should have received a copy of the GNU General Public License along
   with OpenSTA; see the file COPYING.  If not, write to the Free Software
   Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
 
   For more information about the GNU Public license see:
   http://www.gnu.org/copyleft/gpl.html
 
   OpenSTA is at:
   http://www.opensta.org/
   http://opensta.sourceforge.net/
*/

// OpenDocumentDlg.cpp : implementation file
//

#include "stdafx.h"
#include "modeller.h"
#include "OpenDocumentDlg.h"
#include "htmlhelp.h"
#include "Help\OpenDocumentDlg.inl"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// COpenDocumentDlg dialog
extern CModellerApp theApp;

COpenDocumentDlg::COpenDocumentDlg(CWnd* pParent /*=NULL*/)
        : CDialog(COpenDocumentDlg::IDD, pParent)
{
    //{{AFX_DATA_INIT(COpenDocumentDlg)
    // NOTE: the ClassWizard will add member initialization here
    //}}AFX_DATA_INIT
}



void COpenDocumentDlg::DoDataExchange(CDataExchange* pDX)
{
    CDialog::DoDataExchange(pDX);
    //{{AFX_DATA_MAP(COpenDocumentDlg)
    DDX_Control(pDX, IDC_FILE_LIST, m_ctlFileList);
    //}}AFX_DATA_MAP
}



BEGIN_MESSAGE_MAP(COpenDocumentDlg, CDialog)
//{{AFX_MSG_MAP(COpenDocumentDlg)
ON_NOTIFY(NM_DBLCLK, IDC_FILE_LIST, OnDblclkFileList)
ON_WM_CTLCOLOR()
ON_WM_HELPINFO()
//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// COpenDocumentDlg message handlers

void COpenDocumentDlg::OnDblclkFileList(NMHDR* pNMHDR, LRESULT* pResult)
{
    OnOK();

    *pResult = 0;
}

void COpenDocumentDlg::OnOK()
{
    POSITION pos = m_ctlFileList.GetFirstSelectedItemPosition();
    if(!pos)
        return;

    int nItem = m_ctlFileList.GetNextSelectedItem(pos);
    m_strFileName = m_ctlFileList.GetItemText(nItem,0);

    CDialog::OnOK();
}

BOOL COpenDocumentDlg::OnInitDialog()
{
    CDialog::OnInitDialog();

    CStringArray arstrFiles;
    theApp.m_RepositoryAPI.GetProjectTemplateFiles(arstrFiles);

    for(int nFile=0;nFile<arstrFiles.GetSize();nFile++)
        m_ctlFileList.InsertItem(nFile,arstrFiles[nFile]);

    return TRUE;  // return TRUE unless you set the focus to a control
    // EXCEPTION: OCX Property Pages should return FALSE
}


HBRUSH COpenDocumentDlg::OnCtlColor(CDC* pDC, CWnd* pWnd, UINT nCtlColor)
{
    HBRUSH hbr = CDialog::OnCtlColor(pDC, pWnd, nCtlColor);

    if( nCtlColor == CTLCOLOR_STATIC && pWnd->m_hWnd == GetDlgItem(IDC_CAPTION  )->m_hWnd )
    {
        pDC->SetTextColor( RGB( 0 , 0 , 255 ) ) ;
    }

    return hbr;
}

BOOL COpenDocumentDlg::OnHelpInfo(HELPINFO* pHelpInfo)
{
    CString contextHelp;
    contextHelp.LoadString(IDS_MODELLER_HELP_FILE);
    contextHelp= getenv("CYRANO_HOME")+contextHelp+"::whatisthis.txt";

    if (pHelpInfo->iCtrlId == IDC_STATIC)
        return true;

    CWnd* pWnd = GetDlgItem(pHelpInfo->iCtrlId);

	if(pWnd)
	    HtmlHelp(pWnd->m_hWnd, contextHelp, HH_TP_HELP_CONTEXTMENU, (DWORD)(LPVOID)g_TopicIdArray);

    return true;
}
