#if !defined(AFX_SCLCAPTURESCRIPTVIEW_H__2A3A9496_F33E_11D3_AC83_00105A483E3C__INCLUDED_)
#define AFX_SCLCAPTURESCRIPTVIEW_H__2A3A9496_F33E_11D3_AC83_00105A483E3C__INCLUDED_
/* Copyright (C) 2000 Cyrano SA
 
   This file is part of OpenSTA
 
   OpenSTA is free software; you can redistribute it and/or modify it under
   the terms of the GNU General Public License as published by the Free
   Software Foundation; either version 2, or (at your option) any later
   version.
 
   OpenSTA is distributed in the hope that it will be useful, but WITHOUT ANY
   WARRANTY; without even the implied warranty of MERCHANTABILITY or
   FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
   for more details.
 
   You should have received a copy of the GNU General Public License along
   with OpenSTA; see the file COPYING.  If not, write to the Free Software
   Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
 
   For more information about the GNU Public license see:
   http://www.gnu.org/copyleft/gpl.html
 
   OpenSTA is at:
   http://www.opensta.org/
   http://opensta.sourceforge.net/
*/


#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// SCLCaptureScriptView.h : header file
//
#include "OSModellerEditCtrl.h"
/////////////////////////////////////////////////////////////////////////////
// CSCLCaptureScriptView view


class CSCLCaptureScriptView : public CView
{
public:
    COSModellerEditCtrl    m_Editor ;

	char *StripWhiteSpace(char *szLine);

protected:
    CSCLCaptureScriptView();           // protected constructor used by dynamic creation
    DECLARE_DYNCREATE(CSCLCaptureScriptView)

    COSEditCtrl* GetEditCtrl() ;

    // Attributes
public:

    // Operations
public:
    void    SetText(CString _strScript, BOOL _bModify);
    void    MarkLine(int nLine,BOOL bMark=TRUE);
	int		GetMarkedLine();


    // Overrides
    // ClassWizard generated virtual function overrides
    //{{AFX_VIRTUAL(CSCLCaptureScriptView)
public:
    virtual void OnInitialUpdate();
    virtual BOOL OnCmdMsg(UINT nID, int nCode, void* pExtra, AFX_CMDHANDLERINFO* pHandlerInfo);
protected:
    virtual void OnDraw(CDC* pDC);      // overridden to draw this view
    virtual void OnUpdate(CView* pSender, LPARAM lHint, CObject* pHint);
    virtual void OnActivateView(BOOL bActivate, CView* pActivateView, CView* pDeactiveView);
    //}}AFX_VIRTUAL

    // Implementation
protected:
    virtual ~CSCLCaptureScriptView();
#ifdef _DEBUG
    virtual void AssertValid() const;
    virtual void Dump(CDumpContext& dc) const;
#endif

    // Generated message map functions
protected:
    //{{AFX_MSG(CSCLCaptureScriptView)
    afx_msg void OnTogglebookmark();
    afx_msg void OnUpdateTogglebookmark(CCmdUI* pCmdUI);
    afx_msg void OnGoToURL() ;
    afx_msg void OnUpdateGoToURL( CCmdUI *pCmdUI ) ;
    afx_msg int OnCreate(LPCREATESTRUCT lpCreateStruct);
    afx_msg void OnSize(UINT nType, int cx, int cy);
    afx_msg void OnEditCopy();
    afx_msg void OnEditCut();
    afx_msg void OnEditFind();
    afx_msg void OnEditPaste();
    afx_msg void OnEditRedo();
    afx_msg void OnEditReplace();
    afx_msg void OnEditUndo();
    afx_msg void OnUpdateEditCopy(CCmdUI* pCmdUI);
    afx_msg void OnUpdateEditCut(CCmdUI* pCmdUI);
    afx_msg void OnUpdateEditFind(CCmdUI* pCmdUI);
    afx_msg void OnUpdateEditPaste(CCmdUI* pCmdUI);
    afx_msg void OnUpdateEditRedo(CCmdUI* pCmdUI);
    afx_msg void OnUpdateEditReplace(CCmdUI* pCmdUI);
    afx_msg void OnUpdateEditUndo(CCmdUI* pCmdUI);
    afx_msg void OnTimer(UINT nIDEvent);
	afx_msg void OnFindReplaceStrings();
	//}}AFX_MSG
    DECLARE_MESSAGE_MAP()

	char* DoStringReplace(char *szString,const char *szFind,const char* szReplace,char* szInsert,char* szEnd,char** szScript,BOOL bCaseSensitive);
};

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_SCLCAPTURESCRIPTVIEW_H__2A3A9496_F33E_11D3_AC83_00105A483E3C__INCLUDED_)
