#if !defined(AFX_VARPSHEET_H__C610DA83_D959_11D3_930C_00104B4B2995__INCLUDED_)
#define AFX_VARPSHEET_H__C610DA83_D959_11D3_930C_00104B4B2995__INCLUDED_
/* Copyright (C) 2000 Cyrano SA
 
   This file is part of OpenSTA
 
   OpenSTA is free software; you can redistribute it and/or modify it under
   the terms of the GNU General Public License as published by the Free
   Software Foundation; either version 2, or (at your option) any later
   version.
 
   OpenSTA is distributed in the hope that it will be useful, but WITHOUT ANY
   WARRANTY; without even the implied warranty of MERCHANTABILITY or
   FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
   for more details.
 
   You should have received a copy of the GNU General Public License along
   with OpenSTA; see the file COPYING.  If not, write to the Free Software
   Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
 
   For more information about the GNU Public license see:
   http://www.gnu.org/copyleft/gpl.html
 
   OpenSTA is at:
   http://www.opensta.org/
   http://opensta.sourceforge.net/
*/


#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// VarPSheet.h: header file
//

#include <ExtendedPropertySheet.h>
#include "VarGeneralPPage.h"
#include "VarValListDirectPPage.h"
#include "VarValListHTMLPPage.h"
#include "VarValListDBPPage.h"
#include "VarDBPPage.h"
#include "VarDBReqPPage.h"
#include "VarDBColSelPPage.h"
#include "VarDBRowSelPPage.h"
#include "VarFilePPage.h"

#include <VarStructures.h>

/////////////////////////////////////////////////////////////////////////////
// CVarPSheet

class CVarPSheet : public CExtendedPropertySheet
{
    DECLARE_DYNAMIC(CVarPSheet)

    // Attributes
public:

    CVarGeneralPPage            m_Page1 ;
    CVarValListDirectPPage      m_Page10 ;

    CVarFilePPage               m_Page20 ;

    CVarValListHTMLPPage        m_Page32 ;

    CVarDBPPage                 m_Page40 ;
    CVarDBReqPPage              m_Page41 ;
    CVarDBColSelPPage           m_Page42 ;
    CVarDBRowSelPPage           m_Page43 ;
    CVarValListDBPPage          m_Page44 ;

    // Construction
public:
    CVarPSheet( CVarInfo * _VarInfo, BOOL _bCreate, BOOL _bFile = TRUE) ;
    virtual ~CVarPSheet();

    virtual void OnSetActive( CExtendedPropertyPage* _pPage ) ;

    // Operations
public:

    // Overrides
    // ClassWizard generated virtual function overrides
    //{{AFX_VIRTUAL(CVarPSheet)
public:
    virtual BOOL OnInitDialog();
    //}}AFX_VIRTUAL

    // Implementation
public:

    // Generated message map functions
protected:
    //{{AFX_MSG(CVarPSheet)
    // NOTE - the ClassWizard will add and remove member functions here.
    //}}AFX_MSG
    DECLARE_MESSAGE_MAP()

	CVarDBParam m_varDBParam;
};

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_VARPSHEET_H__C610DA83_D959_11D3_930C_00104B4B2995__INCLUDED_)
