/* Copyright (C) 2000 Cyrano SA
 
   This file is part of OpenSTA
 
   OpenSTA is free software; you can redistribute it and/or modify it under
   the terms of the GNU General Public License as published by the Free
   Software Foundation; either version 2, or (at your option) any later
   version.
 
   OpenSTA is distributed in the hope that it will be useful, but WITHOUT ANY
   WARRANTY; without even the implied warranty of MERCHANTABILITY or
   FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
   for more details.
 
   You should have received a copy of the GNU General Public License along
   with OpenSTA; see the file COPYING.  If not, write to the Free Software
   Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
 
   For more information about the GNU Public license see:
   http://www.gnu.org/copyleft/gpl.html
 
   OpenSTA is at:
   http://www.opensta.org/
   http://opensta.sourceforge.net/
*/

// UrlItemInfo.h: interface for the CRequestInfo class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_REQUESTINFO_H__A89FB53B_2D73_4021_86BB_3BB7359EFF0E__INCLUDED_)
#define AFX_REQUESTINFO_H__A89FB53B_2D73_4021_86BB_3BB7359EFF0E__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "ScriptItemInfo.h"

class CRequestInfo;
typedef CArray<const CRequestInfo*,const CRequestInfo*> UrlArray;

class CRequestInfo : public CScriptItemInfo  
{
public:
	CRequestInfo(bool bPrimary, LPCTSTR szUrl,int nConnectionId,int nStartLine,int nEndLine);
	virtual ~CRequestInfo();

#ifdef _DEBUG
	void Dump() const;
#endif

	bool IsHtml()const ;
	bool IsPrimary() const {return m_bPrimary;}
	const CString& GetUrl()const {return m_strUrl;}
	int GetConnectionId()const {return m_nConnectionId;}
private:
	bool m_bPrimary;
	CString m_strUrl;
	int m_nConnectionId;
};

#endif // !defined(AFX_REQUESTINFO_H__A89FB53B_2D73_4021_86BB_3BB7359EFF0E__INCLUDED_)
