/* Copyright (C) 2000 Cyrano SA
 
   This file is part of OpenSTA
 
   OpenSTA is free software; you can redistribute it and/or modify it under
   the terms of the GNU General Public License as published by the Free
   Software Foundation; either version 2, or (at your option) any later
   version.
 
   OpenSTA is distributed in the hope that it will be useful, but WITHOUT ANY
   WARRANTY; without even the implied warranty of MERCHANTABILITY or
   FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
   for more details.
 
   You should have received a copy of the GNU General Public License along
   with OpenSTA; see the file COPYING.  If not, write to the Free Software
   Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
 
   For more information about the GNU Public license see:
   http://www.gnu.org/copyleft/gpl.html
 
   OpenSTA is at:
   http://www.opensta.org/
   http://opensta.sourceforge.net/
*/

///////////////////////////////////////////////////////////////////////////////
// @doc     OtaQueryHandler
// @module  OtaQueryHandler Class | This module contains the base class
//          implementation for query execution
///////////////////////////////////////////////////////////////////////////////

#include <OtaQueryHandler.h>

///////////////////////////////////////////////////////////////////////////////

///////////////////////////////////////////////////////////////////////////////
// Constants

///////////////////////////////////////////////////////////////////////////////
// @mfunc   The constructor initialises the member variables and then opens a
//          performance query.  This query will be used throughout the lifetime
//          of the object.  The constructor is also responsible for registering
//          the object with the NameService.
// @parm    Pointer to CORBA helper functionality.
// @parm    Name of the object.
OtaQueryHandler::OtaQueryHandler()
{
    // Error information
    const char* where = "OtaQueryHandler::OtaQueryHandler";

}

///////////////////////////////////////////////////////////////////////////////
// @mfunc   The destructor does nothing as we cannot guarantyee when it will be
//          called.
OtaQueryHandler::~OtaQueryHandler()
{}


