/* Copyright (C) 2000 Cyrano SA
 
   This file is part of OpenSTA
 
   OpenSTA is free software; you can redistribute it and/or modify it under
   the terms of the GNU General Public License as published by the Free
   Software Foundation; either version 2, or (at your option) any later
   version.
 
   OpenSTA is distributed in the hope that it will be useful, but WITHOUT ANY
   WARRANTY; without even the implied warranty of MERCHANTABILITY or
   FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
   for more details.
 
   You should have received a copy of the GNU General Public License along
   with OpenSTA; see the file COPYING.  If not, write to the Free Software
   Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
 
   For more information about the GNU Public license see:
   http://www.gnu.org/copyleft/gpl.html
 
   OpenSTA is at:
   http://www.opensta.org/
   http://opensta.sourceforge.net/
*/
// NTPerfPluginDoc.cpp : implementation of the CNTPerfPluginDoc class
//

#include "stdafx.h"
#include "NTPerfPlugin.h"

#include "NTPerfPluginDoc.h"
#include "NTPerfPluginView.h"
#include "CntrItem.h"
#include "SrvrItem.h"
#include "OstaDefs.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CNTPerfPluginDoc

IMPLEMENT_DYNCREATE(CNTPerfPluginDoc, COleServerDoc)

BEGIN_MESSAGE_MAP(CNTPerfPluginDoc, COleServerDoc)
	//{{AFX_MSG_MAP(CNTPerfPluginDoc)
		// NOTE - the ClassWizard will add and remove mapping macros here.
		//    DO NOT EDIT what you see in these blocks of generated code!
	//}}AFX_MSG_MAP
	// Enable default OLE container implementation
	ON_UPDATE_COMMAND_UI(ID_EDIT_PASTE, COleServerDoc::OnUpdatePasteMenu)
	ON_UPDATE_COMMAND_UI(ID_EDIT_PASTE_LINK, COleServerDoc::OnUpdatePasteLinkMenu)
	ON_UPDATE_COMMAND_UI(ID_OLE_EDIT_CONVERT, COleServerDoc::OnUpdateObjectVerbMenu)
	ON_COMMAND(ID_OLE_EDIT_CONVERT, COleServerDoc::OnEditConvert)
	ON_UPDATE_COMMAND_UI(ID_OLE_EDIT_LINKS, COleServerDoc::OnUpdateEditLinksMenu)
	ON_COMMAND(ID_OLE_EDIT_LINKS, COleServerDoc::OnEditLinks)
	ON_UPDATE_COMMAND_UI_RANGE(ID_OLE_VERB_FIRST, ID_OLE_VERB_LAST, COleServerDoc::OnUpdateObjectVerbMenu)
END_MESSAGE_MAP()

BEGIN_DISPATCH_MAP(CNTPerfPluginDoc, COleServerDoc)
	//{{AFX_DISPATCH_MAP(CNTPerfPluginDoc)
		// NOTE - the ClassWizard will add and remove mapping macros here.
		//      DO NOT EDIT what you see in these blocks of generated code!
	//}}AFX_DISPATCH_MAP
END_DISPATCH_MAP()

// Note: we add support for IID_INTPerfPlugin to support typesafe binding
//  from VBA.  This IID must match the GUID that is attached to the 
//  dispinterface in the .ODL file.

// {D5638493-1222-4187-A16B-A6E7EDE41557}
static const IID IID_INTPerfPlugin =
{ 0xd5638493, 0x1222, 0x4187, { 0xa1, 0x6b, 0xa6, 0xe7, 0xed, 0xe4, 0x15, 0x57 } };

BEGIN_INTERFACE_MAP(CNTPerfPluginDoc, COleServerDoc)
	INTERFACE_PART(CNTPerfPluginDoc, IID_INTPerfPlugin, Dispatch)
END_INTERFACE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CNTPerfPluginDoc construction/destruction

CNTPerfPluginDoc::CNTPerfPluginDoc()
{
	EnableAutomation();

	AfxOleLockApp();

	OpenClipboard(NULL);
	HANDLE hData = GetClipboardData(RegisterClipboardFormat(strClipboardFormat));
	m_strProfilePath = (char *)GlobalLock(hData);
	GlobalUnlock(hData);
	CloseClipboard();

}

CNTPerfPluginDoc::~CNTPerfPluginDoc()
{
	AfxOleUnlockApp();
}

BOOL CNTPerfPluginDoc::OnNewDocument()
{
	if (!COleServerDoc::OnNewDocument())
		return FALSE;

	// TODO: add reinitialization code here
	// (SDI documents will reuse this document)

	return TRUE;
}

/////////////////////////////////////////////////////////////////////////////
// CNTPerfPluginDoc server implementation

COleServerItem* CNTPerfPluginDoc::OnGetEmbeddedItem()
{
	// OnGetEmbeddedItem is called by the framework to get the COleServerItem
	//  that is associated with the document.  It is only called when necessary.

	CNTPerfPluginSrvrItem* pItem = new CNTPerfPluginSrvrItem(this);
	ASSERT_VALID(pItem);
	return pItem;
}

/////////////////////////////////////////////////////////////////////////////
// CNTPerfPluginDoc Active Document server implementation

CDocObjectServer *CNTPerfPluginDoc::GetDocObjectServer(LPOLEDOCUMENTSITE pDocSite)
{
	return new CDocObjectServer(this, pDocSite);
}



/////////////////////////////////////////////////////////////////////////////
// CNTPerfPluginDoc serialization

void CNTPerfPluginDoc::Serialize(CArchive& ar)
{
}

/////////////////////////////////////////////////////////////////////////////
// CNTPerfPluginDoc diagnostics

#ifdef _DEBUG
void CNTPerfPluginDoc::AssertValid() const
{
	COleServerDoc::AssertValid();
}

void CNTPerfPluginDoc::Dump(CDumpContext& dc) const
{
	COleServerDoc::Dump(dc);
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CNTPerfPluginDoc commands

CString CNTPerfPluginDoc::GetProfilePath()
{
	return m_strProfilePath;
}

BOOL CNTPerfPluginDoc::OnSaveDocument(LPCTSTR lpszPathName) 
{
	POSITION pos = GetFirstViewPosition();
	CNTPerfPluginView* pView = (CNTPerfPluginView*)GetNextView(pos);
	ASSERT(pView);

	pView->WriteProfile(m_strProfilePath);
	
	return COleServerDoc::OnSaveDocument(lpszPathName);
}
