// GraphTypes.h: interface for the CTimerGraph class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_GRAPHTYPES_H__24021AB3_F437_11D3_BD83_00C04F89E392__INCLUDED_)
#define AFX_GRAPHTYPES_H__24021AB3_F437_11D3_BD83_00C04F89E392__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "NTPerfGraphs.h"
#define WMU_DATA_CHANGED (WM_APP+1)

#define GRAPH_MENU_ITEM_ID_START 0x8000
#define GRAPH_MENU_ITEM_ID_END 0x8005

class CXChartCtrl;
//CGraphTypeBase is the base class for all the graph types and
//controls the basic style of the graph,eg background , title
class CGraphTypeBase
{
protected:
    CGraphTypeBase(CXChartCtrl *pChart);

public:
    virtual ~CGraphTypeBase();
    virtual void SetGraphType(int nType);
    virtual int GetGraphType();

    //Called to add a legend to the graph display
    virtual void DisplayLegend();

    virtual BOOL RemoveTestRun(int nRun);

    BOOL ExportToExcel();

    struct MenuItems
    {
        CString strItem;
        UINT uiCommandID;
    };
    typedef CArray<MenuItems,MenuItems&> MenuItemArray;

    virtual void GetMenuItems(MenuItemArray& arMenuItems);
    virtual void OnCommand(UINT uiCommandID,CWnd *pParent);

    //Add all the data from another graph to this one
//    void AddDataFromGraph(CGraphTypeBase *m_pView);

protected:
    int m_nNextGroup;

	CXChartCtrl* m_pChart;
    CString m_strTitle;
};

//CNTPGraph is the base class of all the graphs which use OTA data
class CNTPGraph : public CGraphTypeBase
{
public:
    CNTPGraph(CXChartCtrl *pChart);
    virtual ~CNTPGraph();

	BOOL AddTestRun(NTPHeaderList* pHeader,DWORD dwTestStartTime);
    
    virtual void GetMenuItems(MenuItemArray& arMenuItems);
    virtual void OnCommand(UINT uiCommandID,CWnd *pParent);

protected:
    
    typedef enum{enMenuItemFilter=GRAPH_MENU_ITEM_ID_START}MenuItemIDs;

	NTPHeaderList *m_pListHeaders;
	DWORD m_dwTestStartTime;
};

#endif // !defined(AFX_GRAPHTYPES_H__24021AB3_F437_11D3_BD83_00C04F89E392__INCLUDED_)


