/* Copyright (C) 2000 Cyrano SA
 
   This file is part of OpenSTA
 
   OpenSTA is free software; you can redistribute it and/or modify it under
   the terms of the GNU General Public License as published by the Free
   Software Foundation; either version 2, or (at your option) any later
   version.
 
   OpenSTA is distributed in the hope that it will be useful, but WITHOUT ANY
   WARRANTY; without even the implied warranty of MERCHANTABILITY or
   FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
   for more details.
 
   You should have received a copy of the GNU General Public License along
   with OpenSTA; see the file COPYING.  If not, write to the Free Software
   Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
 
   For more information about the GNU Public license see:
   http://www.gnu.org/copyleft/gpl.html
 
   OpenSTA is at:
   http://www.opensta.org/
   http://opensta.sourceforge.net/
*/

#ifndef _OtaTarget_h
#define _OtaTarget_h

///////////////////////////////////////////////////////////////////////////////
// Standard includes
#include <string>
#ifndef VMS
using std::string;
#endif

///////////////////////////////////////////////////////////////////////////////
#include <mthread.hpp>
#include <mutex.hpp>

#ifdef WIN32
#pragma warning(disable:4786)
#pragma warning(disable:4503)
#endif

class CTLibrary;

static const char *TargetTypes[] =
    {"Unknown", "Sybase", "Oracle", "Microsoft"
    };

class OtaTarget
{
public:
    OtaTarget(string name, int type, string server, string user, string password, int maxrows);
    virtual ~OtaTarget();
    void *GetFunction(CTLibrary lib, string procname);
    void Log();

    CTMutex m_mutex;                // @cmember Thread count guard
    string  m_name;
    int     m_type;
    string  m_server;
    string  m_user;
    string  m_password;
    int     m_maxrows;
    bool    m_error;
};
#endif

