// SNMPGraphs.h: interface for the CSNMPGraphs class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_SNMPGRAPHS_H__30804214_E70F_11D4_94C9_00C04F89E392__INCLUDED_)
#define AFX_SNMPGRAPHS_H__30804214_E70F_11D4_94C9_00C04F89E392__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

class CGraphWnd;

typedef struct
{
	DWORD dwIP;
	int nIndex;
	DWORD dwStartTime;
	DWORD dwEndTime;
	DWORD dwValue;
}SNMPStat;

typedef CList <SNMPStat,SNMPStat&> SNMPStatList;

struct SNMPHeader
{
	bool bInFilter;
	DWORD dwIP;
	int nIndex;
	CString strQuery;

	SNMPHeader()
	{
		bInFilter = true;
	}

	SNMPStatList listStats;
};

typedef CList <SNMPHeader*,SNMPHeader*> SNMPHeaderList;

class CSNMPGraphs  
{
public:
	CSNMPGraphs();
	virtual ~CSNMPGraphs();

	void LoadRun(const CString& strRunFolder);
	CWnd *DisplayGraph(const CString& strName,CWnd *pParent,const CRect& rcBounds);
	void GetAvailableGraphs(CStringArray& arstrGraphs);

private:
	BOOL LoadGraph	(const CString& strName,CGraphWnd *pGraph);
	void LoadStats();

private:
	CString m_strLoadedRun;
	DWORD m_dwTestStartTime;

	SNMPHeaderList m_listSNMPData;

	const CString m_strCustomSNMP;
};

#endif // !defined(AFX_HTTPGRAPHS_H__30804214_E70F_11D4_94C9_00C04F89E392__INCLUDED_)
